var http = require('http');
var restParams = {};
restParams["atg-rest-depth"] = "3";
restParams["atg-rest-show-rest-paths"] = "false";
restParams["arg1"] = "HomeScreenTemplate";
restParams["arg2"] = "{}";
//var url = "https://m.qa.bbby.biz/m/myregistries?supressHeader=true";
//var url = "https://m.qa.bbby.biz/m";
var url = "https://m.qa.bbby.biz/m/myAccount";

http.request({
	type : "POST",
	persistSessionId : true,
	data : {
		"serviceName" : "searchStores",
		"rest-parameters" : restParams
	},
	url : url,
	headers : [{
		name : "Content-Type",
		value : "application/x-www-form-urlencoded; charset=utf-8"
	}, {
		name : "token",
		value : "client123"//Alloy.CFG.token//config-BBB.json
	}, {
		name : "clientID",
		value : "client123"//Alloy.CFG.clientID//config-BBB.json
	}, {
		name : "JSESSIONID",
		value : Ti.App.Properties.getString('JSESSIONID')
	}, {
		name : "CartCookie",
		value : Ti.App.Properties.getString('CartCookie')//cartCookie
	}],
	format : "json",
	success : function(_response) {

		_callback(_response);
	},
	failure : function(_rsp) {
		_error(_rsp);
	}
});

// this sets the background color of the master UIView (when there are no windows/tab groups on it)
Titanium.UI.setBackgroundColor('#000');

// create tab group


//
// create base UI tab and root window
//
var win1 = Titanium.UI.createWindow({
	title : 'Tab 1',
	backgroundColor : '#fff',
	exitOnClose : false,
	layout: "vertical"
});
var btnBack = Titanium.UI.createButton({
    title:"back",
    top: 0,
    left:0,
    zIndex:99
});


var webView = Ti.UI.createWebView({
    top:0,
    left:0

});

btnBack.addEventListener('click', function(){
    webView.goBack();
})
win1.add(btnBack);
win1.add(webView);

win1.open();

Ti.API.info('Loading blank html...');
var htmlFile = 'blank.html';
var f = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory, htmlFile);

var htmlText = f.read();
var htmlString = htmlText.text;

/*
* Load blank html into Webview so we can set the cookie.
* Get the JSESSIONID saved at app startup and pass it as a cookie
*/
//var htmlString = '';

webView.setHtml(htmlString);
webView.setZIndex(3);
webView.addEventListener('load', function(e) {
	var id = Ti.App.Properties.getString('JSESSIONID');
	var cookie = Ti.App.Properties.getString('cookie');
	Ti.API.info('-----------COOKIE LOADED INTO BLANK WEBVIEW: ' + cookie);

	if (cookie && webView) {
		Ti.API.info("document.cookie='" + cookie + "'");
		webView.evalJS("document.cookie='" + cookie + "'");
	}

	if (id && webView) {
		webView.evalJS("document.cookie='JSESSIONID=" + id + "';");
	}
});

//URL
//var _url = 'https://m.qa.bbby.biz/m/cart?supressHeader=true';//attempt 1
//var _url = 'https://m.qa.bbby.biz/m/myregistries?supressHeader=true';//attempt 2
//var _url = "https://m.qa.bbby.biz/m";
var _url = "https://m.qa.bbby.biz/m/myAccount";
webView.setUrl(_url);

webView.addEventListener('load', function(e) {
	Ti.API.info("e URL:" + e.source.url);

	var cookie = null;
	/*
	 Services.getCartCount(function(result){
	 var count = result.BBBCommerceItemCount;
	 //alert('Cart count in web.js: ' + result.BBBCommerceItemCount);
	 Alloy.Globals.updateCartCount(count);
	 });
	 */
	if (webView) {
		cookie = webView.evalJS('document.cookie');
	}
	if (cookie) {
		Ti.API.info('-------------COOKIE IN WEBVIEW RESPONSE: ' + cookie);
		var id = getJsessionId(cookie);
		//var cartCookie = $.getCartCookie(cookie);
		if (webView) {
			webView.evalJS("document.cookie='" + cookie + "'");
		}
		Ti.App.Properties.setString('cookie', cookie);
	}
	if (id) {
		Ti.App.Properties.setString('JSESSIONID', id);
		if (webView) {
			webView.evalJS("document.cookie='JSESSIONID=" + id + "';");
		}
	}
	/*
	 if(cartCookie){
	 Ti.App.Properties.setString('CartCookie', cartCookie);
	 if($.webView){
	 $.webView.evalJS("document.cookie='CartCookie=" + cartCookie + "';");
	 }
	 }*/

	try {
		//$.webView.canGoBack() ? $.navBar.left.setBackgroundImage('/images/backActive.png') : $.navBar.left.setBackgroundImage('/images/backInactive.png');
		//$.webView.canGoForward() ? $.navBar.right.setBackgroundImage('/images/forwardActive.png') : $.navBar.right.setBackgroundImage('/images/forwardInactive.png');
		Ti.API.info('CanGoBack-canGoForward');
	} catch(err) {
		Ti.API.info(' err: ' + err);
	}
});

var getJsessionId = function(cookie) {
	if (cookie.indexOf('JSESSIONID') !== -1) {
		//alert('COOKIE IN getJsessionId ' + cookie);
		var idMarker = 'JSESSIONID=';
		var id;
		var index = cookie.indexOf(idMarker);
		var startCookie = index + idMarker.length;
		var endCookie = cookie.indexOf(';');
		if (endCookie !== -1) {
			var cookies = cookie.split(';');
			for (var i = 0; i < cookies.length; i++) {
				if (cookies[i].indexOf('JSESSIONID') > -1) {
					var marker = 'JSESSIONID=';
					var start = cookies[i].indexOf(marker) + marker.length;
					var end = cookies[i].length;
					var id = cookies[i].substring(start, end);
					//alert('FOUND ID IN FOR LOOP: ' + id);
				}
			}
		} else {//the only cookie so no ';'
			var length = cookie.length;
			id = cookie.substring(startCookie, length);
			//alert('ID AFTER PARSING WITH 1 COOKIE: ' + id);
		}

		//alert('JSESSION ID FROM METHOD: ' + id);
		//Ti.App.Properties.setString('JSESSIONID', id);
		return id;
	}
	return null;
};

        
//var Services = require("services");
//$.params = arguments[0];
//$.hideControllersOnClose = true;

//$.navBar.navBar.backgroundImage = $.params.navBarBackgroundImage;
//$.navBar.navBar.done.backgroundImage = $.params.doneBackgroundImage;

/*
$.navBar.left.addEventListener('click',function(){
   
    try{
        if($.webView.canGoBack() ) {
            $.webView.goBack();
        }
    }catch(err){} 
});

$.navBar.right.addEventListener('click',function(){
    try{
        if($.webView.canGoForward()){
            $.webView.goForward(); 
        } 
    }catch(err){} 
});
*/

/*
$.navBar.navBar.done.addEventListener('touchstart',function(){
    if ( $.navBar && $.navBar.navBar)
    Alloy.Globals.isRegistryView ? $.navBar.navBar.done.setBackgroundImage('/images/doneButtonPressedRegistry.png') : $.navBar.navBar.done.setBackgroundImage('/images/doneButtonPressed.png');
});
*/

/*
$.navBar.navBar.done.addEventListener('touchend',function(){
    if ( $.params && $.params.hideControllersOnClose ) Alloy.Globals.hideContentViews();
    
    if ( $.navBar && $.navBar.navBar)
        Alloy.Globals.isRegistryView ? $.navBar.navBar.done.setBackgroundImage('/images/doneButtonRegistry.png') : $.navBar.navBar.done.setBackgroundImage('/images/doneButton.png');
        
    if( Alloy.Globals.isRegistryView ){
        //re-skin the upper menu
        Alloy.Globals.updateMainMenu();
    }

    $.params.doneFunction();
});
*/

/**
 * Use this to load a URL into the stock webview and display it on the screen with controls
 * A little bit of trickery here because reload and repaint, would not change the webviews URL
 * So we create a temp image to add to the screen to reduce flashing when the webview is removed, recreated and re-added
 * after it has been re-created and added back, we then remove the imageview.
 * 
 * @method showURL
 * @param {string} _url - URL that you want to load the webview with
 * @param {string} _html - HTML that you want loaded into the web view
 */

//$.showURL = function(_url, _html, _hideControllersOnClose){
	/*
	 * Get blank html page from local filesystem
	 * 
	 */
	/*
	Ti.API.info('Loading blank html...');
	var htmlFile = 'html/blank.html';
	var f = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory,
     htmlFile);
     
    var htmlText = f.read();
    var htmlString = htmlText.text;
    
    
    /*
     * Load blank html into Webview so we can set the cookie.
     * Get the JSESSIONID saved at app startup and pass it as a cookie
     */
      //var htmlString = '';
      /*
      $.webView.setHtml(htmlString);
      $.webView.setZIndex(3);
      $.webView.addEventListener('load', function(e){
       	var id = Ti.App.Properties.getString('JSESSIONID');
       	var cookie = Ti.App.Properties.getString('cookie');
       	Ti.API.info('-----------COOKIE LOADED INTO BLANK WEBVIEW: ' + cookie);
       	
        if(cookie && $.webView){
          $.webView.evalJS("document.cookie='"+ cookie + "'");
        }
        
        if(id && $.webView){
             $.webView.evalJS("document.cookie='JSESSIONID=" + id+ "';");
        }
    });
	
    if ( _url){
    	//alert(_url);
        if ( _url.indexOf('delvmpllbbab') > 0 || _url.indexOf('bedbathbeyond') > 0){
            if ( _url.indexOf(Alloy.CFG.supressHeader.replace('&','')) < 0){
                if ( _url.indexOf('&') <0){
                    if ( _url.indexOf('?') < 0)
                        _url = _url + Alloy.CFG.supressHeader.replace(/&/,'?');
                    else
                        _url = _url + Alloy.CFG.supressHeader;
                }
                else {
                    _url = _url + Alloy.CFG.supressHeader;
                }
            }
        }
    }
    
    Ti.API.info("--WebView opening with url " + _url);
    $.hideControllersOnClose = _hideControllersOnClose;
    
    $.webContent.setZIndex(3);
    
    /**
     * The webview didn't like it if we set one or the other to null, 
     * so we set only the required one here and leave the other alone
     */
    /*
    if(_url != null) {
        $.webView.setUrl(_url);
    }
    
    if(_html !=null ) {
        $.webView.setHtml(_html);
        $.webView.setZIndex(3);
    }

    $.webView.addEventListener('load', function(e){
        Ti.API.info("e URL:" + e.source.url);

          var cookie = null;	
          Services.getCartCount(function(result){
          	var count = result.BBBCommerceItemCount;
          	//alert('Cart count in web.js: ' + result.BBBCommerceItemCount);
          	Alloy.Globals.updateCartCount(count);
          });
          if($.webView){
            cookie = $.webView.evalJS('document.cookie');
          }  	
          if(cookie){
          	Ti.API.info('-------------COOKIE IN WEBVIEW RESPONSE: ' + cookie);
          	var id = $.getJsessionId(cookie);
          	var cartCookie = $.getCartCookie(cookie);
          	if($.webView){
          	 $.webView.evalJS("document.cookie='" + cookie + "'");
          	} 
          	Ti.App.Properties.setString('cookie', cookie);
          }
          if(id){
          	Ti.App.Properties.setString('JSESSIONID', id);
          	if($.webView){
          	 $.webView.evalJS("document.cookie='JSESSIONID=" + id+ "';");
          	} 
          }
          if(cartCookie){
          	Ti.App.Properties.setString('CartCookie', cartCookie);
          	if($.webView){
          	 $.webView.evalJS("document.cookie='CartCookie=" + cartCookie + "';");
          	} 
          }
          
          try{
                $.webView.canGoBack() ? $.navBar.left.setBackgroundImage('/images/backActive.png') : $.navBar.left.setBackgroundImage('/images/backInactive.png');
                $.webView.canGoForward() ? $.navBar.right.setBackgroundImage('/images/forwardActive.png') : $.navBar.right.setBackgroundImage('/images/forwardInactive.png');
            }catch(err){}
        });
    
};
/*
if ( $.params.html != null){
    if ( $.params && $.params.hideControllersOnClose){
        $.showURL($.params.url, $.params.html, $.params.hideControllersOnClose);
    }
}
else {
    Alloy.Globals.getFinalUrl($.params.url,function(_url){
        if ( $.params && $.params.hideControllersOnClose){
            $.showURL(_url, null, $.params.hideControllersOnClose);
        }
        else if ( $.params){
            $.showURL(_url, null, false);
        }
    });
}*/
//$.showURL($.params.url, $.params.html, $.params.hideControllersOnClose);

/*
$.shutdown = function(){
    $.webContent.remove($.webView);
    $.webView = null;
    $.webContent = null;
    $.showURL = null;
    $.params = null;
    arguments[0] = null;
    $.hideControllersOnClose = null;
    $.navBar.shutdown();
};
*/
/*
 * Function to parse JSESSIONID from cookie
 * 
 */
/*
$.getJsessionId = function(cookie){
	if(cookie.indexOf('JSESSIONID') !== -1){
	//alert('COOKIE IN getJsessionId ' + cookie);
	 var idMarker = 'JSESSIONID=';	
	 var id;
	 var index = cookie.indexOf(idMarker);
	 var startCookie = index + idMarker.length;
	 var endCookie = cookie.indexOf(';');
	 if(endCookie !== -1){
	   var cookies = cookie.split(';');
	   for(var i=0; i<cookies.length; i++){
	  	  if(cookies[i].indexOf('JSESSIONID') > -1){
	  	  	    var marker = 'JSESSIONID=';
	   	  		var start = cookies[i].indexOf(marker) + marker.length;
	   	  		var end = cookies[i].length;
	   	  		var id = cookies[i].substring(start, end);
	   	  		//alert('FOUND ID IN FOR LOOP: ' + id);
	   	   }
	   	  }
	 }else{  //the only cookie so no ';'
	 	var length = cookie.length;
	 	id = cookie.substring(startCookie, length);
	 	//alert('ID AFTER PARSING WITH 1 COOKIE: ' + id);
	 } 
	 
	 //alert('JSESSION ID FROM METHOD: ' + id);
	 //Ti.App.Properties.setString('JSESSIONID', id);
	 return id;
	}
	return null;
};
*/

/*
 * Function to parse CartCookie from cookie
 * 
 */

/*
$.getCartCookie = function(cookie){
	if(cookie.indexOf('CartCookie') !== -1){
	//alert('COOKIE IN getCartCookie ' + cookie);
	 var idMarker = 'CartCookie=';	
	 var id;
	 var index = cookie.indexOf(idMarker);
	 var startCookie = index + idMarker.length;
	 var endCookie = cookie.indexOf(';');
	 if(endCookie !== -1){
	   var cookies = cookie.split(';');
	   for(var i=0; i<cookies.length; i++){
	  	  if(cookies[i].indexOf('CartCookie') > -1){
	  	  	    var marker = 'CartCookie=';
	   	  		var start = cookies[i].indexOf(marker) + marker.length;
	   	  		var end = cookies[i].length;
	   	  		var id = cookies[i].substring(start, end);
	   	  		//alert('FOUND CART ID IN FOR LOOP: ' + id);
	   	   }
	   	  }
	 }else{  //the only cookie so no ';'
	 	var length = cookie.length;
	 	id = cookie.substring(startCookie, length);
	 	//alert('ID AFTER PARSING WITH 1 COOKIE: ' + id);
	 } 
	 
	 //alert('JSESSION ID FROM METHOD: ' + id);
	 //Ti.App.Properties.setString('JSESSIONID', id);
	 return id;
	}
	return null;
};
*/


